#!/usr/bin/perl -w

# modified 26.7.2005

#======================================================================
# definice retezcovych promennych
#======================================================================
$named_conf_fek = <<_EOM_;
zone "fek.zcu.cz" {
     	type master;
     	file "db.fek.zcu.cz";
	allow-update { none; };
};

zone "igzh.cas.cz" {
        type master;
        file "db.igzh.cas.cz";
        allow-update { none; };
};
_EOM_
#zone "190.228.147.in-addr.arpa" {
#        type master;
#        file "db.147.228.190.cz";
#        allow-update { none; };
#};
#
#
#zone "193.228.147.in-addr.arpa" {
#       type master;
#	file "db.147.228.193.cz";
#       allow-update { none; };
#};
#
#
#zone "244.231.147.in-addr.arpa" {
#        type master;
#        file "db.147.231.244.cz";
#        allow-update { none; };
#};

																		
$also_notify = <<_EOM2_;
	also-notify {
		147.228.57.20;
                147.228.57.10;
                147.228.60.10;
                147.228.52.11;
                147.228.221.13;
                147.228.221.12;
                147.228.209.2;
                147.228.52.200;
        };
_EOM2_

#======================================================================

print "\n\n";
print "=================================\n";
print " project: Sauron DNS import\n";
print " script:  prepare_import_DNS1.pl\n";
print " version: 1.0\n";
print "=================================\n\n";


#vytvoreni adresarove struktury
mkdir DNS_IMPORT;
mkdir DNS_ADDITIVE;
mkdir DNS_REMOVED;

#modifikace souboru 'ZCU\named.conf'
&ModifyNamedConf();

#modifikace souboru 'db.zcu.cz'
&ModifyDbZcuCz();

#modifikace souboru 'db.147.228'
&ModifyDb147_228();

#kopie nezmenenych souboru potrebnych k importu
print "\nCopying files ...\n";
`cp zcu/db.127.0.0 DNS_IMPORT/db.127.0.0`;
`cp zcu/DB-ZONE.NEW DNS_IMPORT/DB-ZONE.NEW`;
`cp zcu/DB-REVERSE.NEW DNS_IMPORT/DB-REVERSE.NEW`;
`cp zcu/db.localhost-ipv6 DNS_ADDITIVE/db.localhost-ipv6`;
`cp zcu/db.bind-version DNS_ADDITIVE/db.bind-version`;
`cp zcu/db.hes.cache DNS_ADDITIVE/db.hes.cache`;
`cp zcu/db.hesiod DNS_ADDITIVE/db.hesiod`;
`cp zcu/DB-SRV DNS_ADDITIVE/DB-SRV`;
`cp zcu/db.srv-peek.krb DNS_ADDITIVE/db.srv-peek.krb`;
`cp zcu/db.srv.krb DNS_ADDITIVE/db.srv.krb`;


`cp fek/db.fek.zcu.cz DNS_IMPORT/db.fek.zcu.cz`;
`cp fek/bootptab-cheb-dns DNS_IMPORT/bootptab-cheb-dns`;
`cp fek/bootptab-cheb-rev DNS_IMPORT/bootptab-cheb-rev`;
`cp fek/db.igzh.cas.cz DNS_IMPORT/db.igzh.cas.cz`;
`cp fek/db.147.228.190.cz DNS_IMPORT/db.147.228.190.cz`;
`cp fek/db.147.228.193.cz DNS_IMPORT/db.147.228.193.cz`;
`cp fek/db.147.231.244.cz DNS_IMPORT/db.147.231.244.cz`;

`cp pef/db.pef.zcu.cz DNS_IMPORT/db.pef.zcu.cz`;
#for($i=150;$i<180;$i++){
#   `cp PEF/db.147.228.$i DNS_IMPORT/db.147.228.$i`;
#}
print "  ...completed\n";

print "\n\nEnd of script\n\n";

#======================================================================
# sub ModifyNamedConf
#======================================================================

sub ModifyNamedConf{
	#---------------------------------------------------------------
	print "\nModifying file 'ZCU/named.conf' ...\n";

	open(ZCU_IN, "<zcu/named.conf");
	open(ZCU_IMPORT, ">DNS_IMPORT/named.conf");
	open(ZCU_ADDITIVE, ">DNS_ADDITIVE/named.conf");
	open(ZCU_REMOVED, ">DNS_REMOVED/named.conf");
	
	$tofile = 1;
	$writelines= 0;
	$writenextline=0;
	$nextline = "";
	while($line = <ZCU_IN>){
		if ($writelines == 0){
			#presun zony "ns.zcu.cz" typu hesiod
			if ($line =~ "zone \"ns.zcu.cz\" hesiod {"){
				printf "  zone \"ns.zcu.cz\" type hesiod --> dns_additive/named.conf\n";
				$writelines = 5;	#zona je na 4 radkach + 1 mezera
				$tofile = 2;
			}

			#presun zony "." typu hesiod
			if (($line =~ "zone \".\" hesiod") && ($writelines == 0)){
				printf "  zone \".\" type hesiod --> dns_additive/named.conf\n";
				$writelines = 5;	#zona je na 4 radkach + 1 mezera
				$tofile = 2;
			}

			#presun zony "bind" typu chaos
			if (($line =~ "zone \"bind\" chaos") && ($writelines ==0)){
				printf "  zone \"bind\" type chaos --> dns_additive/named.conf\n";
				$writelines = 6;	#zona je na 5 radkach + 1 mezera
				$tofile = 2;
			}
			
			#presun zon s pochybnou maskou
			if (($line =~ "zone \"(0|64|128)\/") && ($writelines == 0)){
				printf "  zone \"(0|64|128)/... --> dns_additive/named.conf\n";
				$writelines = 8;	#zona je na 7 radkach + 1 mezera
				$tofile = 2;
			}
			
			#presun zony pro IPv6 		
			if (($line =~ "zone \"1.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.ip6.int.") && ($writelines==0)){
				printf "  zone for IPv6 --> dns_additive/named.conf\n";			
				$writelines = 5;	#zona je na 4 radkach + 1 mezera
				$tofile = 2;	
			}
	
			#likvidace zony "pef.zcu.cz" a "fek.zcu.cz" typu in
			if ($line =~ "zone \"(pef|fek).zcu.cz\""){
				printf "  zone \"(pef|fek).zcu.cz\" --> dns_removed/named.conf\n";
				$writelines = 7;	#zona je na 7 radkach
				$tofile = 3;
			}
			
			#likvidace reverznich zon pro "pef.zcu.cz" a "fek.zcu.cz" typu in
			if (($line =~ "zone \"[0-9]{3}.228.147.in-addr.arpa") && ($writelines == 0)){
				printf "  zone  \"[0-9]{3}.228.147.in-addr.arpa\" --> dns_removed/named.conf\n";
				$writelines = 7;	#zona je na 7 radkach
				$tofile = 3;
			}
			
			#likvidace komentaru
			if (($line =~ "//") && ($writelines == 0)){
				#printf "  comment --> dns_removed/named.conf\n";
				$writelines = 1;	#komentar je na jednom radku
				$tofile = 3;
			}


			#zjisteni slave zony
			#print "$writelines\n";
			if (($line =~ "zone \"") && ($writelines == 0)){
			  $nextline = <ZCU_IN>;
			  #print "line = $line $nextline";
			  #printf "line = $line";
			  if ($nextline =~ ".*type slave;"){
			    $tofile = 2;
			    $writelines = 8;
			  }
			  else{
			    $tofile = 1;
			    $writelines = 2;
			  } 
			  $writenextline = 1;
			}
			
			#implicitne je nerozpoznany radek zarazen k importu
			if ($writelines == 0){
			  $writelines = 1;
			  $tofile = 1;
			  #printf $writelines;
			}
		} #if $writelines=0
	
		#zapis radku
		if ($writelines > 0){
		  if (($tofile != 3) && ($line =~ "//")){
		    #print "  comment --> empty line\n" ;
		    $line = "\n"
		  }

  		  if ($tofile == 1){
  		    print ZCU_IMPORT $line;
		  }
		  if ($tofile == 2){
		    print ZCU_ADDITIVE $line;
		  }
		  if ($tofile == 3){
		    print ZCU_REMOVED $line;
		  }
		  
		  $writelines--;
		}
		
		#modifikace pro nextline
		if ($writenextline==1){
		  $writenextline = 0;
		  $writelines--;
		  
  		  if ($tofile == 1){
  		    print ZCU_IMPORT $nextline;
		    #print $nextline;
		  }
		  if ($tofile == 2){
		    #print $nextline;
		    print ZCU_ADDITIVE $nextline;
		  }
		  if ($tofile == 3){
		    print ZCU_REMOVED $nextline;
		  }
		  
		}
	}

	close(ZCU_IN);
	close(ZCU_ADDITIVE);
	close(ZCU_REMOVED);
	#---------------------------------------------------------------
	# pridani zon definovanych na FEK
	print ZCU_IMPORT "//zony definovane na FEK\n\n";
	print ZCU_IMPORT $named_conf_fek; 
	
	
	#---------------------------------------------------------------
	# pridani zon definovanych na PEF
	print ZCU_IMPORT "//zony definovane na PEF\n\n";
	
	#for($i=150;$i<180;$i++){
	#   print ZCU_IMPORT "zone \"$i.228.147.in-addr.arpa\" {\n";
	#   print ZCU_IMPORT "	type master;\n";
	#   print ZCU_IMPORT "	file \"db.147.228.$i\";\n";
	#   print ZCU_IMPORT "$also_notify";
	#   print ZCU_IMPORT "};\n\n";
	#}
	print ZCU_IMPORT "zone \"pef.zcu.cz\" {\n";
	print ZCU_IMPORT "	type master;\n";
	print ZCU_IMPORT "	file \"db.pef.zcu.cz\";\n";
	print ZCU_IMPORT "$also_notify";
	#print ZCU_IMPORT "also_notify {\n147.228.12.12;\n};\n";
	print ZCU_IMPORT "};\n\n";
	close(ZCU_IMPORT);

	print "  ... completed\n";
	#---------------------------------------------------------------
} #end of sub ModifyNamedConf


#======================================================================
# sub ModifyDbZcuCz
#======================================================================

sub ModifyDbZcuCz{

	#---------------------------------------------------------------
	print "\nModifying file 'zcu/db.zcu.cz' ...\n";

	open(ZCU_IN, "<zcu/db.zcu.cz");
	open(ZCU_OUT, ">DNS_IMPORT/db.zcu.cz");

	$comment = 0;
	while($line = <ZCU_IN>){
		if ($comment == 0){
			#zakomentovani radky $INCLUDE DB-SRV 		
			if ($line =~ ".INCLUDE DB-SRV"){
				printf "  DB-SRV including disabled\n";			
				$comment = 1;	#tj. zakomentovani 1 radek
			}
			#zakomentovani delegace pef
			if ($line =~ "; Delegeting a subdomain \"pef.zcu.cz\""){
				printf "  PEF delegation disabled\n";			
				$comment = 5;	#tj. zakomentovani 5 radek
			}
			#zakomentovani delegace fek
			if ($line =~ "; Delegeting a subdomain \"fek.zcu.cz\""){
				printf "  FEK delegation disabled\n";			
				$comment = 4;	#tj. zakomentovani 4 radek
			}
		} #if comment==0
	
		#je-li radek vynechavan, prida se znak komentare
		if ($comment > 0){
			print ZCU_OUT ";"; #znak komentare v tomto souboru je strednik
			$comment--;
		}
		#zapis puvodniho radku
		print ZCU_OUT $line;
	}

	close(ZCU_IN);
	close(ZCU_OUT);

	print "  ... completed\n";
	#---------------------------------------------------------------
} #end of sub ModifyDbZcuCz


#======================================================================
# sub ModifyDb147_228
#======================================================================

sub ModifyDb147_228{

	#---------------------------------------------------------------
	print "\nModifying file 'ZCU/db.147.228' ...\n";

	open(ZCU_IN, "<zcu/db.147.228");
	open(ZCU_OUT, ">DNS_IMPORT/db.147.228");

	$comment = 0;
	while($line = <ZCU_IN>){
		if ($comment == 0){
			#zakomentovani delegace pef
			if ($line =~ "; zone \"150-179.228.147.in-addr.arpa\" PeF"){
				printf "  PEF Delegation disabled\n";			
				$comment = 92;	#tj. zakomentovani 92 radek
			}
			#zakomentovani delegace fek
			if ($line =~ "; zone \"190.228.147.in-addr.arpa\" FEK Cheb"){
				printf "  FEK delegation disabled\n";			
				$comment = 4;	#tj. zakomentovani 4 radek
			}
		} #if comment==0
	
		#je-li radek vynechavan, prida se znak komentare
		if ($comment > 0){
			print ZCU_OUT ";"; #znak komentare v tomto souboru je strednik
			$comment--;
		}
		#zapis puvodniho radku
		print ZCU_OUT $line;
	}

	close(ZCU_IN);
	close(ZCU_OUT);

	print "  ... completed\n";
	#---------------------------------------------------------------
} #end of sub ModifyDb147_228

# eof
