#!/usr/bin/perl -w

print "\n\n";
print "=================================\n";
print " project: Sauron DNS import\n";
print " script:  prepare_import_DNS2.pl\n";
print " version: 2.0\n";
print " modified: 26.7.2005\n";
print "=================================\n\n";

#======================================================
# nastaveni skriptu - zasahy delejte pouze zde
#======================================================

# vstupni zonovy soubor db.zcu.cz (vcetne pripadne cesty)
$db_zcu_cz_file = "DNS_IMPORT/db.zcu.cz";

# vstupni zonovy soubor db.pef.zcu.cz
$db_pef_zcu_cz_file = "DNS_IMPORT/db.pef.zcu.cz";

# domenova jmena ktera se maji presunout ze zony pef.zcu do zony zcu.cz
# netyka se zaznamu switch a gateway (ty jsou upraveny skritem prepare_import_DNS3.pl)
@domain_names = (
 "vc112p01-jis.civ.zcu.cz."
);

# pocet radku ktere patri k odpovidajicimu zaznamu v poli domain_names
@rows = (2);

#======================================================
# vlastni skript
#======================================================

# kopie souboru db.zcu.cz (ochrana proti pusteni tehoz skriptu dvakrat na dany soubor
`cp $db_zcu_cz_file $db_zcu_cz_file.temp`;

$out_db_zcu_cz_file = "$db_zcu_cz_file";
$out_db_pef_zcu_cz_file = "$db_pef_zcu_cz_file";

open(OUT_ZCU, ">>$db_zcu_cz_file.temp");
open(OUT_PEF, ">$db_pef_zcu_cz_file.temp");
open(IN_PEF, "<$db_pef_zcu_cz_file");

print OUT_ZCU "\n; zaznamy prevedene z db.pef.zcu.cz\n\n";

print "Searching for selected domain_names ...\n";
$lineindex=0;
while($line = <IN_PEF>){
  $lineindex++;
  $writeorigline = 1;

  $j=0;
  foreach(@domain_names){
    # hledani jednotlivych jmen
    if ($line =~ "^$_"){
      print "  '$_,' detected in line $lineindex-",$rows[$j]+$lineindex-1,"\n";
      
      #zmena v souboru
      print OUT_ZCU $line;
      print OUT_PEF ";$line";

      for($i=0;$i < ($rows[$j] - 1);$i++){
        $line2 = <IN_PEF>;
	#print "Max(i)=",($rows[$j]-1),"\n";
	print OUT_ZCU $line2;
	print OUT_PEF ";$line2";
      } #for
      $writeorigline = 0;
    } #if
    $j++;
  }

  if ($writeorigline == 1){
    print OUT_PEF $line
  }
  
}

close(OUT_ZCU);
close(OUT_PEF);
close(IN_PEF);
# presun tempovych souboru na finalni misto

`mv $db_zcu_cz_file.temp $out_db_zcu_cz_file`;
`mv $db_pef_zcu_cz_file.temp $out_db_pef_zcu_cz_file`;

print "  ...completed\n";

print "\n\nEnd of script\n\n";

